class DEVAPI {
	// html5+ 对象
	HTML5_PLUS_REFLECT_BROADCASTRECEIVER = "io.dcloud.feature.internal.reflect.BroadcastReceiver" // html5+ 创建数据监听api
	HTML5_PLUS_CONTENT_INTENT = "android.content.Intent" // html5+ 初始化上下文
	HTML5_PLUS_CONTENT_INTENTFILTER = "android.content.IntentFilter" // html5+ 暴露接口
	HTML5_PLUS_KEY_DOWN = "com.aoro.poc.key.down" // 按钮被按下
	HTML5_PLUS_RUNTIME_MAIN_ACTIVITY = null // 设备活动

	// 广播对象
	POC_KEY_DOWN_OBJ = null

	// 扫描对象
	SCANOBJ = {
		SCAN_SERVICE: "com.action.INIT_SCAN", // 扫描权限
		SCAN_RESULT: "com.action.SCAN_RESULT", // 扫描结果
		SCAN_BEGIN: "com.action.START_SCAN", // 开始扫描
		SCAN_POCKEY_ENABLE: "com.action.SCAN_POCKEY_ENABLE", // 按键功能
		SCAN_END: "com.action.STOP_SCAN", // 关闭扫描
	}

	// RFID 对象
	RFID_SDK_WX = null
	// 0红外扫描  1 RFID
	TYPE_DEV_JQHWGEVIQUWVILBE = 1

	// RFID 时间
	RFIDIntervalTime = null

	// RFID type 
	ISRFIDOPEN = false

	constructor() {}
	// 监听按钮被按下--
	initDevAPI() {
		this.initRFID() // RFID 初始化
		// 意图
		let HTML5_PLUS_CONTENT_INTENT_CLASS = plus.android.importClass(this.HTML5_PLUS_CONTENT_INTENT);
		this.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY = plus.android.runtimeMainActivity(); // HTML5_PLUS 获取 activity
		// 权限
		let intentServer = new HTML5_PLUS_CONTENT_INTENT_CLASS(this.SCANOBJ.SCAN_SERVICE);
		this.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.sendBroadcast(intentServer);
		
		// HTML5_PLUS 创建数据监听函数
		this.POC_KEY_DOWN_OBJ = plus.android.implements(
			this.HTML5_PLUS_REFLECT_BROADCASTRECEIVER, {
				onReceive: (context, intent) => {
					// 红外扫描结果
					if (intent.getAction() === this.SCANOBJ.SCAN_RESULT) {
						console.log("scan====res")
						// uni.off('scancodemsg')
						
						let _data_ = intent.getByteArrayExtra("scanContext")
						let codeStr = this.byteToString(_data_)
						console.log(`回调数据:${codeStr}`)
						uni.$emit('scancodemsg', {
							msg: codeStr
						})
					}
					else{
						console.log(111)
						return
					}
				}
			}
		);

		let that = this
		plus.key.addEventListener("keyup", function(e) {
			console.log(e.keyCode)
			if (e.keyCode == 131 && that.TYPE_DEV_JQHWGEVIQUWVILBE === 0) {
				console.log("按键被按下，开启红外扫描")
				that.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.unregisterReceiver(that.POC_KEY_DOWN_OBJ); // 注册
				let IntentFilter = plus.android.importClass(that.HTML5_PLUS_CONTENT_INTENTFILTER); // 暴露接口对象
				let filter = new IntentFilter();
				filter.addAction(that.SCANOBJ.SCAN_RESULT); // 红外 扫描结果，广播
				that.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.registerReceiver(that.POC_KEY_DOWN_OBJ,filter); // 注册功能 
			} else if (e.keyCode == 131 && that.TYPE_DEV_JQHWGEVIQUWVILBE === 1) {
				console.log("按键被按下，开启RFID")
				that.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.unregisterReceiver(that.POC_KEY_DOWN_OBJ); // 注册
				that.ISRFIDOPEN = !that.ISRFIDOPEN
				if (that.ISRFIDOPEN === true) {
					console.log("开启RFID")
					that.RFIDStartInventory()
				}
				if(that.ISRFIDOPEN !== true&&that.RFIDIntervalTime==0){
					console.log("开启RFID")
					that.RFIDStartInventory()
				}
				if(that.ISRFIDOPEN !== true&&that.RFIDIntervalTime!=0){
					console.log("关闭RFID")
					that.RFIDStopInventory()
				}
			}
			else{
				return;
			}

		}, false);
	}
	// 设置扫描和RFID的开关 0扫描  1RFID
	isRFIDAndSCAN(type) {
		this.TYPE_DEV_JQHWGEVIQUWVILBE = type
	}

	// 初始化RFID
	initRFID() {
		console.log("RFID--------开始")
		// RFID 插件对象
		this.RFID_SDK_WX = uni.requireNativePlugin("Lizii-uhfmagic-sdk");
		//初始化sdk，在启动的第一个页面调用一次即可
		let that = this
		this.RFID_SDK_WX.setCallback(function(res) {
			console.log(res);
			var event = res.event;
			if (event == "onInventoryOnce") {
				// res.data  epc 数组  没有信号强度
				let arr = []
				res.data.map(item => {
					let codeStr = item.slice(6, 14)
					console.log(codeStr)
					codeStr = parseInt(codeStr, 16) + ""
					uni.$emit('scancodemsg', {
						msg: codeStr
					})
					console.log(`回调数据:${codeStr}`)
				})
			}
			if (event == "onEpc") {
				// res.data  epc 数组  没有信号强度
				let arr = []
				res.data.map(item => {
					let codeStr = item.slice(6, 14)
					codeStr = parseInt(codeStr, 16) + ""
					console.log(codeStr)
					arr.push(codeStr)
				})
				uni.$emit('scancodeList', {
					msg: arr
				})
				console.log(`回调数据:${arr}`)
			}
		});

		this.RFID_SDK_WX.init({
			serialPortPath: "/dev/ttysWK2", //串口地址 ，不传默认为‘/dev/ttysWK2’
			power: 26 //功率，不传默认26 取值14-26
		});
	}

	// 开始存盘
	RFIDStartInventory() {
		if (this.RFIDIntervalTime === 0) {
			this.RFID_SDK_WX.inventoryOnce(true);
			// this.RFID_SDK_WX.inventoryOnce(false);
		} else {
			this.RFID_SDK_WX.inventoryRealTime(true);
		}
	}

	// 停止存盘
	RFIDStopInventory() {
		this.RFID_SDK_WX.inventoryRealTime(false);
	}

	// 获取设备 数据列表
	RFIDGetDATAList() {
		if (this.RFID_SDK_WX) {
			var tagList = this.RFID_SDK_WX.getTagList();
			return tagList
		}
	}

	byteToString(arr) {
		if (typeof arr === 'string') {
			return arr;
		}
		var str = '',
			_arr = arr;
		for (var i = 0; i < _arr.length; i++) {
			var one = _arr[i].toString(2),
				v = one.match(/^1+?(?=0)/);
			if (v && one.length == 8) {
				var bytesLength = v[0].length;
				var store = _arr[i].toString(2).slice(7 - bytesLength);
				for (var st = 1; st < bytesLength; st++) {
					store += _arr[st + i].toString(2).slice(2);
				}
				str += String.fromCharCode(parseInt(store, 2));
				i += bytesLength - 1;
			} else {
				str += String.fromCharCode(_arr[i]);
			}
		}
		return str;
	}

}

export {
	DEVAPI
}